'
' ####################
' #####  PROLOG  #####
' ####################
'
' Create VBScript Host Engine
' Base on article by Jeff Glatt, COM in plain C, Part 6.
' How to write an ActiveX Script Host in C.
' http://www.codeproject.com/com/com_in_c6.asp

m4_define(`OFFSETOF',`(&$1.$2 - &$1)')

VERSION "0.0001"
CONSOLE

	TYPE WORD = USHORT
	TYPE DWORD = ULONG
	TYPE LONG = SLONG
	TYPE HKEY = XLONG
	TYPE BSTR = XLONG
	TYPE OLECHAR = USHORT
	TYPE SCRIPTTHREADID = DWORD

	TYPE MyRealIActiveScriptSite
		XLONG .site
		XLONG .siteWnd
	END TYPE

	TYPE IActiveScriptSiteWindowVtbl
		FUNCADDR .siteWnd_QueryInterface(XLONG, XLONG, XLONG)
		FUNCADDR .siteWnd_AddRef(XLONG)
		FUNCADDR .siteWnd_Release(XLONG)
		FUNCADDR .GetSiteWindow(XLONG, XLONG)
		FUNCADDR .EnableModeless(XLONG, XLONG)
	END TYPE

	TYPE IActiveScriptSiteVtbl
		FUNCADDR .QueryInterface(XLONG, XLONG, XLONG)
		FUNCADDR .AddRef(XLONG)
		FUNCADDR .Release(XLONG)
		FUNCADDR .GetLCID(XLONG, XLONG)
		FUNCADDR .GetItemInfo(XLONG, XLONG, XLONG, XLONG, XLONG)
		FUNCADDR .GetDocVersionString(XLONG, XLONG)
		FUNCADDR .OnScriptTerminate(XLONG, XLONG, XLONG)
		FUNCADDR .OnStateChange(XLONG, XLONG)
		FUNCADDR .OnScriptError(XLONG, XLONG)
		FUNCADDR .OnEnterScript(XLONG)
		FUNCADDR .OnLeaveScript(XLONG)
	END TYPE
'
	IMPORT "xst"				' Standard library : required by most programs
	IMPORT "xsx"				' Extended standard library
'	IMPORT "xio"				' Console input/ouput library

'	IMPORT "xst_s.lib"
' IMPORT "xsx_s.lib"
' IMPORT "xio_s.lib"

	IMPORT "gdi32"			' gdi32.dll
	IMPORT "user32"		  ' user32.dll
	IMPORT "kernel32"	  ' kernel32.dll
'	IMPORT "shell32"		' shell32.dll
	IMPORT "msvcrt"		  ' msvcrt.dll

	IMPORT "ole32"
	IMPORT "advapi32"
	IMPORT "oleaut32"

DECLARE FUNCTION Entry ()
DECLARE FUNCTION getEngineGuid (extension$, GUID guidBuffer)
DECLARE FUNCTION IActiveScript_QueryInterface (lpIUnknown, riid, ppvObj)
DECLARE FUNCTION initIActiveScriptSiteObject ()
DECLARE FUNCTION QueryInterface(this, riid, ppv)
DECLARE FUNCTION AddRef (this)
DECLARE FUNCTION Release (this)
DECLARE FUNCTION GetItemInfo (this, objectName, DWORD dwReturnMask, objPtr, typeInfo)
DECLARE FUNCTION OnScriptError(this, scriptError)
DECLARE FUNCTION GetLCID (this, lcid)
DECLARE FUNCTION GetDocVersionString (this, version)
DECLARE FUNCTION OnScriptTerminate (this, pvr, pei)
DECLARE FUNCTION OnStateChange (this, state)
DECLARE FUNCTION OnEnterScript (this)
DECLARE FUNCTION OnLeaveScript (this)
DECLARE FUNCTION IsEqualGUID (rguid1, rguid2)
DECLARE FUNCTION siteWnd_QueryInterface (this, riid, ppv)
DECLARE FUNCTION siteWnd_AddRef (this)
DECLARE FUNCTION siteWnd_Release (this)
DECLARE FUNCTION GetSiteWindow (this, phwnd)
DECLARE FUNCTION EnableModeless (this, enable)
DECLARE FUNCTION IActiveScriptError_GetExceptionInfo (lpIUnknown, pexcepinfo)
DECLARE FUNCTION IActiveScriptError_GetSourcePosition (lpIUnknown, pdwSourceContext, pulLineNumber, plCharacterPosition)
DECLARE FUNCTION IActiveScriptError_GetSourceLineText (lpIUnknown, pbstrSourceLine)
DECLARE FUNCTION display_COM_error (msg$, hr)
DECLARE FUNCTION runScript (GUID guid)
DECLARE FUNCTION IActiveScriptParse_InitNew (lpIUnknown)
DECLARE FUNCTION IActiveScriptParse_AddScriptlet (lpIUnknown, pstrDefaultName, pstrCode, pstrItemName, pstrSubItemName, pstrEventName, pstrDelimiter, ULONG dwSourceContextCookie, ULONG ulStartingLineNumber, ULONG dwFlags, pbstrName, pexcepinfo)
DECLARE FUNCTION IActiveScriptParse_ParseScriptText (lpIUnknown, pstrCode, pstrItemName, punkContext, pstrDelimiter, ULONG dwSourceContextCookie, ULONG ulStartingLineNumber, ULONG dwFlags, pvarResult, pexcepinfo)
DECLARE FUNCTION IActiveScript_SetScriptSite (lpIUnknown, pass)
DECLARE FUNCTION IActiveScript_GetScriptSite (lpIUnknown, riid, ppvObject)
DECLARE FUNCTION IActiveScript_SetScriptState (lpIUnknown, ss)
DECLARE FUNCTION IActiveScript_GetScriptState (lpIUnknown, pssState)
DECLARE FUNCTION IActiveScript_Close (lpIUnknown)
DECLARE FUNCTION IActiveScript_AddNamedItem (lpIUnknown, pstrName, ULONG dwFlags)
DECLARE FUNCTION IActiveScript_AddTypeLib (lpIUnknown, rguidTypeLib, ULONG dwMajor, ULONG dwMinor, ULONG dwFlags)
DECLARE FUNCTION IActiveScript_GetScriptDispatch (lpIUnknown, pstrItemName, ppdisp)
DECLARE FUNCTION IActiveScript_GetCurrentScriptThreadID (lpIUnknown, pstidThread)
DECLARE FUNCTION IActiveScript_GetScriptThreadID (lpIUnknown, ULONG dwWin32ThreadID, pstidThread)
DECLARE FUNCTION IActiveScript_GetScriptThreadState (lpIUnknown, stidThread, pstsState)
DECLARE FUNCTION IActiveScript_InterruptScriptThread (lpIUnknown, stidThread, pexcepinfo, ULONG dwFlags)
DECLARE FUNCTION IActiveScript_Clone (lpIUnknown, ppscript)
DECLARE FUNCTION IActiveScriptParse_Release (lpIUnknown)
DECLARE FUNCTION IActiveScript_Release (lpIUnknown)
DECLARE FUNCTION WSTRING$ (addrWString)

$$IID_IActiveScript 					= "\xE1\x2A\x1A\xBB\xF9\xA4\xCF\x11\x8F\x20\x00\x80\x5F\x2C\xD0\x64"
'IID_IActiveScriptParse, 0xbb1a2ae2, 0xa4f9, 0x11cf, 0x8f,0x20, 0x00,0x80,0x5f,0x2c,0xd0,0x64)
$$IID_IActiveScriptParse 			= "\xE2\x2A\x1A\xBB\xF9\xA4\xCF\x11\x8F\x20\x00\x80\x5F\x2C\xD0\x64"
'$$IID_IVBS = "\x41\x37\x4F\xB5\x07\x5B\xCF\x11\xA4\xB0\x00\xAA\x00\x4A\x55\xE8"
'IID_IActiveScriptSite, 0xdb01a1e3, 0xa42b, 0x11cf, 0x8f,0x20, 0x00,0x80,0x5f,0x2c,0xd0,0x64
$$IID_IActiveScriptSite 			= "\xe3\xa1\x01\xdb\x2b\xa4\xcf\x11\x8f\x20\x00\x80\x5f\x2c\xd0\x64"
'IID_IActiveScriptSiteWindow, 0xd10f6761, 0x83e9, 0x11cf, 0x8f,0x20, 0x00,0x80,0x5f,0x2c,0xd0,0x64)
$$IID_IActiveScriptSiteWindow = "\x61\x67\x0f\xd1\xe9\x83\xcf\x11\x8f\x20\x00\x80\x5f\x2c\xd0\x64"
'IID_IUnknown = new Guid("00000000-0000-0000-C000-000000000046")
$$IID_IUnknown 								= "\x00\x00\x00\x00\x00\x00\x00\x00\xc0\x00\x00\x00\x00\x00\x00\x46"
'IID_IActiveScriptError, 0xeae1ba61, 0xa4ed, 0x11cf, 0x8f,0x20, 0x00,0x80,0x5f,0x2c,0xd0,0x64)
$$IID_IActiveScriptError 			= "\x61\xba\xe1\xea\xed\xa4\xcf\x11\x8f\x20\x00\x80\x5f\x2c\xd0\x64"

$$SCRIPTINFO_IUNKNOWN            = 0x1
$$SCRIPTINFO_ITYPEINFO           = 0x2
$$SCRIPTINFO_ALL_FLAGS           = 0x3
$$SCRIPTINTERRUPT_DEBUG          = 0x1
$$SCRIPTINTERRUPT_RAISEEXCEPTION = 0x2
$$SCRIPTINTERRUPT_ALL_FLAGS      = 0x3
$$SCRIPTSTAT_STATEMENT_COUNT     = 1
$$SCRIPTSTAT_INSTRUCTION_COUNT   = 2
$$SCRIPTSTAT_INTSTRUCTION_TIME   = 3
$$SCRIPTSTAT_TOTAL_TIME          = 4

$$SCRIPTSTATE_UNINITIALIZED 		= 0
$$SCRIPTSTATE_STARTED 					= 1
$$SCRIPTSTATE_CONNECTED 				= 2
$$SCRIPTSTATE_DISCONNECTED 			= 3
$$SCRIPTSTATE_CLOSED 						= 4
$$SCRIPTSTATE_INITIALIZED 			= 5

$$SCRIPTTHREADSTATE_NOTINSCRIPT = 0
$$SCRIPTTHREADSTATE_RUNNING     = 1

'#define SCRIPTTHREADID_CURRENT ((SCRIPTTHREADID)-1)
'#define SCRIPTTHREADID_BASE ((SCRIPTTHREADID)-2)
'#define SCRIPTTHREADID_ALL ((SCRIPTTHREADID)-3)

$$SCRIPTITEM_ISVISIBLE          = 0x00000002
$$SCRIPTITEM_ISSOURCE           = 0x00000004
$$SCRIPTITEM_GLOBALMEMBERS      = 0x00000008
$$SCRIPTITEM_ISPERSISTENT       = 0x00000040
$$SCRIPTITEM_CODEONLY           = 0x00000200
$$SCRIPTITEM_NOCODE             = 0x00000400
$$SCRIPTITEM_ALL_FLAGS          = 0x0000064E 		' (SCRIPTITEM_ISSOURCE | SCRIPTITEM_ISVISIBLE |SCRIPTITEM_ISPERSISTENT | SCRIPTITEM_GLOBALMEMBERS | SCRIPTITEM_NOCODE | SCRIPTITEM_CODEONLY)
$$SCRIPTTYPELIB_ISCONTROL       = 0x00000010
$$SCRIPTTYPELIB_ISPERSISTENT    = 0x00000040
$$SCRIPTTYPELIB_ALL_FLAGS       = 0x00000050    ' (SCRIPTTEXT_ISCONTROL | SCRIPTTYPELIB_ISPERSISTENT)
$$SCRIPTTEXT_DELAYEXECUTION     = 0x00000001
$$SCRIPTTEXT_ISVISIBLE          = 0x00000002
$$SCRIPTTEXT_ISEXPRESSION       = 0x00000020
$$SCRIPTTEXT_ISPERSISTENT       = 0x00000040
$$SCRIPTTEXT_HOSTMANAGESSOURCE  = 0x00000080
$$SCRIPTTEXT_ALL_FLAGS          = 0x000000E3    ' (SCRIPTTEXT_DELAYEXECUTION | SCRIPTTEXT_ISVISIBLE | SCRIPTTEXT_ISEXPRESSION | SCRIPTTEXT_ISPERSISTENT | SCRIPTTEXT_HOSTMANAGESSOURCE)
$$SCRIPTPROC_HOSTMANAGESSOURCE  = 0x00000080
$$SCRIPTPROC_IMPLICIT_THIS      = 0x00000100
$$SCRIPTPROC_IMPLICIT_PARENTS   = 0x00000200
$$SCRIPTPROC_ALL_FLAGS          = 0x00000380    ' (SCRIPTPROC_HOSTMANAGESSOURCE | SCRIPTPROC_IMPLICIT_THIS | SCRIPTPROC_IMPLICIT_PARENTS)

FUNCTION Entry ()

	GUID guidBuffer
	SHARED MyRealIActiveScriptSite MyActiveScriptSite

	' Initialize COM DLL
	hr = CoInitialize(0)
	IF (hr) THEN
		display_COM_error ("Failed to initialize COM: %08X", hr)
	ELSE
		' Initialize MyRealIActiveScriptSite object
		initIActiveScriptSiteObject()

		' Find the script engine to use for files that end with a .VBS extension.
		' NOTE: Microsoft's VBscript engine sets up an association in the
		' registry for this extension.
		IF (!getEngineGuid(".vbs", @guidBuffer)) THEN
			' Now that we've got the engine GUID, run the script
			runScript (@guidBuffer)
		END IF

		' Allow our IActiveScriptSite to free any resources
		Release (&MyActiveScriptSite)
	END IF

	' Free COM
	CoUninitialize()

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION

FUNCTION getEngineGuid (extension$, GUID guidBuffer)

	HKEY hk, subKey
	DWORD size, type

	buffer$ = NULL$ (200)

	' See if this file extension is associated
	' with an ActiveX script engine
	IF (!RegOpenKeyExA ($$HKEY_CLASSES_ROOT, &extension$, 0, $$KEY_QUERY_VALUE | $$KEY_READ, &hk)) THEN
		type = $$REG_SZ
		size = SIZE (buffer$)
		ret = RegQueryValueExA (hk, 0, 0, &type, &buffer$, &size)
		RegCloseKey (hk)
		IF (ret == $$ERROR_SUCCESS) THEN

			' The engine set an association.
			' We got the Language string in buffer[]. Now
			' we can use it to look up the engine's GUID

			' Open HKEY_CLASSES_ROOT\{LanguageName}
again:
			size = SIZE (buffer$)
			ret = RegOpenKeyExA ($$HKEY_CLASSES_ROOT, &buffer$, 0, $$KEY_QUERY_VALUE | $$KEY_READ, &hk)
			IFZ ret THEN
				' Read the GUID (in string format)
				' into buffer[] by querying the value of CLSID
				ret = RegOpenKeyExA (hk, &"CLSID", 0, $$KEY_QUERY_VALUE | $$KEY_READ, &subKey)
				IFZ ret THEN
					ret = RegQueryValueExW (subKey, 0, 0, &type, &buffer$, &size)
					RegCloseKey (subKey)

				ELSE
					IF (extension$) THEN

						' If an error, see if we have a "ScriptEngine"
						' key under here that contains
						' the real language name
						IF (!RegOpenKeyExA (hk, &"ScriptEngine", 0, $$KEY_QUERY_VALUE | $$KEY_READ, &subKey)) THEN
							ret = RegQueryValueExA (subKey, 0, 0, &type, &buffer$, &size)
							RegCloseKey (subKey)
							IF (!ret) THEN
								RegCloseKey (hk)
								extension$ = ""
								GOTO again
							END IF
						END IF
					END IF
				END IF
			END IF

			RegCloseKey (hk)

			IFZ ret THEN
				' Convert the GUID string to a GUID
				' and put it in caller's guidBuffer
				ret = CLSIDFromString (&buffer$, &guidBuffer)
				IF (ret) THEN
					MessageBoxA (0, &"Can't convert engine GUID", &"Error", $$MB_OK | $$MB_ICONEXCLAMATION)
				END IF
				RETURN (ret)
			END IF
		END IF
	END IF

	MessageBoxA (0, &"Can't get engine GUID from registry", &"Error", $$MB_OK | $$MB_ICONEXCLAMATION)
	RETURN ($$E_FAIL)

END FUNCTION

FUNCTION IActiveScript_QueryInterface (lpIUnknown, riid, ppvObj)

	FUNCADDR QueryInterface (XLONG, XLONG, XLONG)

	vtblAddr       = XLONGAT (lpIUnknown)
	QueryInterface = XLONGAT (vtblAddr)
	IFZ QueryInterface THEN RETURN ($$TRUE)

	RETURN @QueryInterface (lpIUnknown, riid, ppvObj)

END FUNCTION

FUNCTION initIActiveScriptSiteObject ()

	SHARED MyRealIActiveScriptSite MyActiveScriptSite
	SHARED IActiveScriptSiteWindowVtbl SiteWindowTable
	SHARED IActiveScriptSiteVtbl SiteTable

	SiteWindowTable.siteWnd_QueryInterface 	= &siteWnd_QueryInterface()
	SiteWindowTable.siteWnd_AddRef 					= &siteWnd_AddRef()
	SiteWindowTable.siteWnd_Release 				= &siteWnd_Release()
	SiteWindowTable.GetSiteWindow 					= &GetSiteWindow()
	SiteWindowTable.EnableModeless					= &EnableModeless()

	SiteTable.QueryInterface 								= &QueryInterface()
	SiteTable.AddRef 												= &AddRef()
	SiteTable.Release 											= &Release()
	SiteTable.GetLCID 											= &GetLCID()
	SiteTable.GetItemInfo 									= &GetItemInfo()
	SiteTable.GetDocVersionString 					= &GetDocVersionString()
	SiteTable.OnScriptTerminate 						= &OnScriptTerminate()
	SiteTable.OnStateChange 								= &OnStateChange()
	SiteTable.OnScriptError 								= &OnScriptError()
	SiteTable.OnEnterScript 								= &OnEnterScript()
	SiteTable.OnLeaveScript 								= &OnLeaveScript()

	MyActiveScriptSite.site 		= &SiteTable
	MyActiveScriptSite.siteWnd 	= &SiteWindowTable

END FUNCTION

FUNCTION QueryInterface (this, riid, ppv)

	SHARED MyRealIActiveScriptSite MyActiveScriptSite
	' An ActiveX Script Host is supposed to provide an object
	' with multiple interfaces, where the base object is an
	' IActiveScriptSite, and there is an IActiveScriptSiteWindow
	' sub-object. Therefore, a caller can pass an IUnknown or
	' IActiveScript VTable GUID if he wants our IActiveScriptSite.
	' Or, the caller can pass a IActiveScriptSiteWindow VTable
	' GUID if he wants our IActiveScriptSiteWindow sub-object
	IF (IsEqualGUID(riid, &$$IID_IUnknown) || IsEqualGUID(riid, &$$IID_IActiveScriptSite)) THEN
		XLONGAT(ppv) = this
	ELSE
		IF (IsEqualGUID(riid, &$$IID_IActiveScriptSiteWindow)) THEN
			XLONGAT(ppv) = this + OFFSETOF(MyActiveScriptSite, siteWnd)
		ELSE
			XLONGAT(ppv) = 0
			RETURN ($$E_NOINTERFACE)
		END IF
	END IF
	AddRef (this)
	RETURN ($$S_OK)
END FUNCTION

FUNCTION AddRef (this)
	' Since our MyRealIActiveScriptSite is not allocated, but instead
	' declared statically, we have no need to maintain a reference
	' count
	RETURN (1)
END FUNCTION

FUNCTION Release (this)
	' Since our MyRealIActiveScriptSite is not allocated, but instead
	' declared statically, we have no need to maintain a reference
	' count, nor free it.
	'
	' NOTE: If our MyRealIActiveScriptSite did contain some resources
	' that we had to free, then we'd need to maintain a reference
	' count, and free those resources when the reference count was
	' zero
	RETURN (1)
END FUNCTION

' Called by the script engine to get any pointers to our own host-defined
' objects whose functions a script may directly call. We don't implement
' any such objects here, so this is just a stub.
FUNCTION GetItemInfo (this, objectName, DWORD dwReturnMask, objPtr, typeInfo)
	IF (dwReturnMask & $$SCRIPTINFO_IUNKNOWN) THEN XLONGAT(objPtr) = 0
	IF (dwReturnMask & $$SCRIPTINFO_ITYPEINFO) THEN XLONGAT(typeInfo) = 0
	RETURN ($$E_FAIL)
END FUNCTION

FUNCTION IActiveScriptError_GetExceptionInfo (lpIUnknown, pexcepinfo)

	FUNCADDR GetExceptionInfo (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GetExceptionInfo	= XLONGAT (vtblAddr + 0x0C)
	IFZ GetExceptionInfo THEN RETURN ($$TRUE)

	RETURN @GetExceptionInfo (lpIUnknown, pexcepinfo)

END FUNCTION

FUNCTION IActiveScriptError_GetSourcePosition (lpIUnknown, pdwSourceContext, pulLineNumber, plCharacterPosition)

	FUNCADDR GetSourcePosition (XLONG, XLONG, XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GetSourcePosition	= XLONGAT (vtblAddr + 0x10)
	IFZ GetSourcePosition THEN RETURN ($$TRUE)

	RETURN @GetSourcePosition (lpIUnknown, pdwSourceContext, pulLineNumber, plCharacterPosition)

END FUNCTION

FUNCTION IActiveScriptError_GetSourceLineText (lpIUnknown, pbstrSourceLine)

	FUNCADDR GetSourceLineText (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GetSourceLineText	= XLONGAT (vtblAddr + 0x14)
	IFZ GetSourceLineText THEN RETURN ($$TRUE)

	RETURN @GetSourceLineText (lpIUnknown, pbstrSourceLine)

END FUNCTION

' Called by the script engine when there is an error running/parsing a script.
' The script engine passes us its IActiveScriptError object whose functions
' we can call to get information about the error, such as the line/character
' position (in the script) where the error occurred, an error message we can
' display to the user, etc. Typically, our OnScriptError will get the error
' message and display it to the user.
FUNCTION OnScriptError(this, scriptError)

	ULONG	lineNumber
	EXCEPINFO	ei

	' Call GetSourcePosition() to retrieve the line # where
	' the error occurred in the script
	IActiveScriptError_GetSourcePosition (scriptError, 0, &lineNumber, 0)

	' Call GetSourceLineText() to retrieve the line in the script that
	' has an error.
	'
	' Note: The IActiveScriptError is supposed to clear our BSTR pointer
	' if it can't return the line. So we shouldn't have to do
	' that first. But you may need to uncomment the following line
	' if a script engine isn't properly written. Unfortunately, too many
	' engines are not written properly, so we uncomment it
	source = 0
	IActiveScriptError_GetSourceLineText (scriptError, &source)
	IF source THEN src$ = WSTRING$(source)

	' Call GetExceptionInfo() to fill in our EXCEPINFO struct with more
	' information.
	'
	' Note: The IActiveScriptError is supposed to zero out any fields of
	' our EXCEPINFO that it doesn't fill in. So we shouldn't have to do
	' that first. But you may need to uncomment the following line
	' if a script engine isn't properly written
'	ZeroMemory(&ei, SIZE(ei))
	IActiveScriptError_GetExceptionInfo (scriptError, &ei)

	IF ei.bstrSource THEN error$ = WSTRING$(ei.bstrSource)
	IF ei.bstrDescription THEN desc$ = WSTRING$(ei.bstrDescription)

	' Format the message we'll display to the user
	msg$ = error$ + "\nLine " + STRING$(lineNumber + 1) + ": " + desc$
	IF src$ THEN
		msg$ = msg$ + "\n" + src$
	END IF

	' Free what we got from the IActiveScriptError functions
	SysFreeString (source)
	SysFreeString (ei.bstrSource)
	SysFreeString (ei.bstrDescription)
	SysFreeString (ei.bstrHelpFile)

	' Display the message
	err$ = "Error"
	MessageBoxA (0, &msg$, &err$, $$MB_SETFOREGROUND | $$MB_OK | $$MB_ICONEXCLAMATION)

	RETURN ($$S_OK)
END FUNCTION

' Called when the script engine wants to know what language ID our
' program is using.
FUNCTION GetLCID (this, lcid)
	XLONGAT(lcid) = $$LOCALE_USER_DEFAULT
	RETURN ($$S_OK)
END FUNCTION

' Called when the script engine wishes to retrieve the version number
' (as a string) for the current document. We are expected to return a
' SysAllocString()'ed BSTR copy of this version string.
'
' Here's what I believe this is for. An engine may implement some
' IPersist object. When we AddScriptlet or ParseScriptText some
' script with the SCRIPTTEXT_ISPERSISTENT flag, then the script
' engine will save that script to disk for us, when we call the
' engine IPersist's Save() function. But maybe the engine wants to
' minimize unnecessary saving to disk. So, it fetches this version
' string and caches it when it does the first save to disk. Then,
' when we subsequently call IPersist Save again, the engine fetches
' this version string again, and compares it to the previous version
' string. If the same string, then the engine assumes the script doesn't
' need to be resaved. If different, then the engine assumes our
' document has changed and therefore it should resave the scripts.
' In other words, this is used simply as an "IsDirty" flag by IPersist
' Save to see if a persistant script needs to be resaved. I don't
' believe that engines without any IPersist object bother with this,
' and I have seen example engines _with_ an IPersist that don't
' bother with it.
FUNCTION GetDocVersionString (this, version)
	' We have no document versions
	XLONGAT(version) = 0

	' If an engine chokes on the above, try this instead:
'	if (!(*version = SysAllocString(&EmptyStr[0])))
'		return(E_OUTOFMEMORY);

	RETURN ($$S_OK)
END FUNCTION

' Called when the engine has completely finished running scripts and
' has returned to INITIALIZED state. In many engines, this is not
' called because an engine alone can't determine when we are going
' to stop running/adding scripts to it.
FUNCTION OnScriptTerminate (this, pvr, pei)
	RETURN ($$S_OK)
END FUNCTION

' Called when the script engine's state is changed (for example, by
' us calling the engine IActiveScript->SetScriptState). We're passed
' the new state.
FUNCTION OnStateChange (this, state)
	RETURN ($$S_OK)
END FUNCTION

' Called right before the script engine executes/interprets each
' script added via the engine IActiveScriptParse->ParseScriptText()
' or AddScriptlet(). This is also called when our IApp object
' calls some function in the script.
FUNCTION OnEnterScript (this)
	RETURN ($$S_OK)
END FUNCTION

' Called immediately after the script engine executes/interprets
' each script.
FUNCTION OnLeaveScript (this)
	RETURN ($$S_OK)
END FUNCTION

FUNCTION IsEqualGUID (rguid1, rguid2)

	RETURN !memcmp (rguid1, rguid2, SIZE(GUID))
END FUNCTION

FUNCTION siteWnd_QueryInterface (this, riid, ppv)

	SHARED MyRealIActiveScriptSite MyActiveScriptSite

	' Since our IActiveScriptSiteWindow is a sub-object embedded inside of our
	' MyRealIActiveScriptSite object (ie, our MyRealIActiveScriptSite has "multiple
	' interfaces" and our IActiveScriptSiteWindow happens to be a sub-object),
	' then we just delegate to our base object's (IActiveScriptSite's) QueryInterface
	' to do the real work. We do this by substituting our IActiveScriptSite object for
	' the "this" pointer. That's easy to do because both our IActiveScriptSiteWindow
	' and IActiveScriptSite objects are embedded inside of our one MyRealIActiveScriptSite.
	' So a little pointer arithmatic gets us what we want
	this = this - OFFSETOF(MyActiveScriptSite, siteWnd)
	RETURN (QueryInterface (this, riid, ppv))
END FUNCTION

FUNCTION siteWnd_AddRef (this)
	SHARED MyRealIActiveScriptSite MyActiveScriptSite
	this = this - OFFSETOF(MyActiveScriptSite, siteWnd)
	RETURN (AddRef (this))
END FUNCTION

FUNCTION siteWnd_Release (this)
	SHARED MyRealIActiveScriptSite MyActiveScriptSite
	this = this - OFFSETOF(MyActiveScriptSite, siteWnd)
	RETURN (Release (this))
END FUNCTION

' Called by the script engine when it wants to know what window it should
' use as the owner of any dialog box the engine presents.
FUNCTION GetSiteWindow (this, phwnd)
	' We have no app window
	XLONGAT(phwnd) = 0
	RETURN ($$S_OK)
END FUNCTION

' Called when the script engine wants us to enable/disable all of our open
' windows.
FUNCTION EnableModeless (this, enable)
	' We have no open windows
	RETURN ($$S_OK)
END FUNCTION

FUNCTION display_COM_error (msg$, hr)

	buffer$ = NULL$(256)
	sprintf (&buffer$, &msg$, hr)
	MessageBoxA (0, &buffer$, &"Error", $$MB_OK | $$MB_ICONEXCLAMATION)

END FUNCTION

FUNCTION runScript (GUID guid)
 ' Runs our VBscript.
 ' guid =	GUID of the script engine that runs the script.
 ' If an error, this displays a message box.
 ' script$ must be unicode

	GUID riid
	CLSID clsid
	SHARED MyRealIActiveScriptSite MyActiveScriptSite
	SHARED IActiveScriptSiteWindowVtbl SiteWindowTable
	SHARED IActiveScriptSiteVtbl SiteTable

'	register HRESULT	hr;
'	IActiveScriptParse	*activeScriptParse;
'	IActiveScript		*activeScript;

	' Create an instance of the script engine, and get its IActiveScript object
	XLONGAT(&&clsid) = &guid
	XLONGAT(&&riid) = &$$IID_IActiveScript
	hr = CoCreateInstance (&clsid, 0, $$CLSCTX_ALL, &riid, &activeScript)
	IF (hr) THEN
		display_COM_error ("Can't get engine's IActiveScript: %08X", hr)
	ELSE
		' Get the script engine's IActiveScriptParse object (which we can do from its
		' IActiveScript's QueryInterface since IActiveScriptParse is a
		' sub-object of the IActiveScript)
		XLONGAT(&&riid) = &$$IID_IActiveScriptParse
		hr = IActiveScript_QueryInterface (activeScript, &riid, &activeScriptParse)

		IF (hr) THEN
			display_COM_error ("Can't get engine's IActiveScriptParse: %08X", hr)
		ELSE
			' Initialize the engine. This just lets the engine internally
			' initialize some stuff in preparation of us adding scripts to it
			' for the first time
			hr = IActiveScriptParse_InitNew (activeScriptParse)
			IF (hr) THEN
				display_COM_error ("Can't initialize engine : %08X", hr)
			ELSE
				' Give the engine our IActiveScriptSite object. If all goes well,
				' the engine will call its QueryInterface (which will AddRef it)
				hr = IActiveScript_SetScriptSite (activeScript, &MyActiveScriptSite)
				IF (hr) THEN
					display_COM_error ("Can't set our IScriptSite : %08X", hr)
				ELSE
					' Have the script engine parse the script and add it to its internal
					' list of scripts to run
					sc$ = "MsgBox \"Hello world\""
					VBscript$ = XstAnsiToUnicode$ (sc$)
					hr = IActiveScriptParse_ParseScriptText (activeScriptParse, &VBscript$, 0, 0, 0, 0, 0, 0, 0, 0)

					' NOTE: If the script engine has a problem parsing/tokenizing the script, it will
					' have called our IActiveScriptSite's OnScriptError() to display an error msg, so
					' we don't need to do that here
					IF (!hr) THEN
						' Set engine's state to CONNECTED. Our above script will run now
						hr = IActiveScript_SetScriptState (activeScript, $$SCRIPTSTATE_CONNECTED)
						IF (hr) THEN
							display_COM_error ("Engine can't connect events: %08X", hr)
						END IF
					END IF
				END IF
			END IF

			' Release script engine's IActiveScriptParse
			IActiveScriptParse_Release (activeScriptParse)
		END IF

		' We're supposed to Close() the engine before we Release() the IActiveScript
		IActiveScript_Close (activeScript)

		' Release script engine's IActiveScript
		IActiveScript_Release (activeScript)
	END IF

END FUNCTION

FUNCTION IActiveScriptParse_InitNew (lpIUnknown)

	FUNCADDR InitNew (XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	InitNew	= XLONGAT (vtblAddr + 0x0C)
	IFZ InitNew THEN RETURN ($$TRUE)

	RETURN @InitNew (lpIUnknown)

END FUNCTION

FUNCTION IActiveScriptParse_AddScriptlet (lpIUnknown, pstrDefaultName, pstrCode, pstrItemName, pstrSubItemName, pstrEventName, pstrDelimiter, ULONG dwSourceContextCookie, ULONG ulStartingLineNumber, ULONG dwFlags, pbstrName, pexcepinfo)

	FUNCADDR AddScriptlet (XLONG, XLONG, XLONG, XLONG, XLONG, XLONG, XLONG, ULONG, ULONG, ULONG, XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	AddScriptlet	= XLONGAT (vtblAddr + 0x10)
	IFZ AddScriptlet THEN RETURN ($$TRUE)

	RETURN @AddScriptlet (lpIUnknown, pstrDefaultName, pstrCode, pstrItemName, pstrSubItemName, pstrEventName, pstrDelimiter, dwSourceContextCookie, ulStartingLineNumber, dwFlags, pbstrName, pexcepinfo)

END FUNCTION

FUNCTION IActiveScriptParse_ParseScriptText (lpIUnknown, pstrCode, pstrItemName, punkContext, pstrDelimiter, ULONG dwSourceContextCookie, ULONG ulStartingLineNumber, ULONG dwFlags, pvarResult, pexcepinfo)

	FUNCADDR ParseScriptText (XLONG, XLONG, XLONG, XLONG, XLONG, ULONG, ULONG, ULONG, XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	ParseScriptText	= XLONGAT (vtblAddr + 0x14)
	IFZ ParseScriptText THEN RETURN ($$TRUE)

	RETURN @ParseScriptText (lpIUnknown, pstrCode, pstrItemName, punkContext, pstrDelimiter, dwSourceContextCookie, ulStartingLineNumber, dwFlags, pvarResult, pexcepinfo)

END FUNCTION

FUNCTION IActiveScript_SetScriptSite (lpIUnknown, pass)

	FUNCADDR SetScriptSite (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	SetScriptSite	= XLONGAT (vtblAddr + 0x0C)
	IFZ SetScriptSite THEN RETURN ($$TRUE)

	RETURN @SetScriptSite (lpIUnknown, pass)

END FUNCTION

FUNCTION IActiveScript_GetScriptSite (lpIUnknown, riid, ppvObject)

	FUNCADDR GetScriptSite (XLONG, XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GetScriptSite	= XLONGAT (vtblAddr + 0x10)
	IFZ GetScriptSite THEN RETURN ($$TRUE)

	RETURN @GetScriptSite (lpIUnknown, riid, ppvObject)

END FUNCTION

FUNCTION IActiveScript_SetScriptState (lpIUnknown, ss)

	FUNCADDR SetScriptState (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	SetScriptState	= XLONGAT (vtblAddr + 0x14)
	IFZ SetScriptState THEN RETURN ($$TRUE)

	RETURN @SetScriptState (lpIUnknown, ss)

END FUNCTION

FUNCTION IActiveScript_GetScriptState (lpIUnknown, pssState)

	FUNCADDR GetScriptState (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GetScriptState	= XLONGAT (vtblAddr + 0x18)
	IFZ GetScriptState THEN RETURN ($$TRUE)

	RETURN @GetScriptState (lpIUnknown, pssState)

END FUNCTION

FUNCTION IActiveScript_Close (lpIUnknown)

	FUNCADDR Close (XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	Close	= XLONGAT (vtblAddr + 0x1C)
	IFZ Close THEN RETURN ($$TRUE)

	RETURN @Close (lpIUnknown)

END FUNCTION

FUNCTION IActiveScript_AddNamedItem (lpIUnknown, pstrName, ULONG dwFlags)

	FUNCADDR AddNamedItem (XLONG, XLONG, ULONG)

	vtblAddr = XLONGAT (lpIUnknown)
	AddNamedItem	= XLONGAT (vtblAddr + 0x20)
	IFZ AddNamedItem THEN RETURN ($$TRUE)

	RETURN @AddNamedItem (lpIUnknown, pstrName, dwFlags)

END FUNCTION

FUNCTION IActiveScript_AddTypeLib (lpIUnknown, rguidTypeLib, ULONG dwMajor, ULONG dwMinor, ULONG dwFlags)

	FUNCADDR AddTypeLib (XLONG, XLONG, ULONG, ULONG, ULONG)

	vtblAddr = XLONGAT (lpIUnknown)
	AddTypeLib	= XLONGAT (vtblAddr + 0x24)
	IFZ AddTypeLib THEN RETURN ($$TRUE)

	RETURN @AddTypeLib (lpIUnknown, rguidTypeLib, wMajor, dwMinor, dwFlags)

END FUNCTION

FUNCTION IActiveScript_GetScriptDispatch (lpIUnknown, pstrItemName, ppdisp)

	FUNCADDR GetScriptDispatch (XLONG, XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GetScriptDispatch	= XLONGAT (vtblAddr + 0x28)
	IFZ GetScriptDispatch THEN RETURN ($$TRUE)

	RETURN @GetScriptDispatch (lpIUnknown, pstrItemName, ppdisp)

END FUNCTION

FUNCTION IActiveScript_GetCurrentScriptThreadID (lpIUnknown, pstidThread)

	FUNCADDR GetCurrentScriptThreadID (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GetCurrentScriptThreadID	= XLONGAT (vtblAddr + 0x2C)
	IFZ GetCurrentScriptThreadID THEN RETURN ($$TRUE)

	RETURN @GetCurrentScriptThreadID (lpIUnknown, pstidThread)

END FUNCTION

FUNCTION IActiveScript_GetScriptThreadID (lpIUnknown, ULONG dwWin32ThreadID, pstidThread)

	FUNCADDR GetScriptThreadID (XLONG, ULONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GetScriptThreadID	= XLONGAT (vtblAddr + 0x30)
	IFZ GetScriptThreadID THEN RETURN ($$TRUE)

	RETURN @GetScriptThreadID (lpIUnknown, dwWin32ThreadID, pstidThread)

END FUNCTION

FUNCTION IActiveScript_GetScriptThreadState (lpIUnknown, stidThread, pstsState)

	FUNCADDR GetScriptThreadState (XLONG, XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GetScriptThreadState	= XLONGAT (vtblAddr + 0x34)
	IFZ GetScriptThreadState THEN RETURN ($$TRUE)

	RETURN @GetScriptThreadState (lpIUnknown, stidThread, pstsState)

END FUNCTION

FUNCTION IActiveScript_InterruptScriptThread (lpIUnknown, stidThread, pexcepinfo, ULONG dwFlags)

	FUNCADDR InterruptScriptThread (XLONG, XLONG, XLONG, ULONG)

	vtblAddr = XLONGAT (lpIUnknown)
	InterruptScriptThread	= XLONGAT (vtblAddr + 0x38)
	IFZ InterruptScriptThread THEN RETURN ($$TRUE)

	RETURN @InterruptScriptThread (lpIUnknown, stidThread, pexcepinfo, dwFlags)

END FUNCTION

FUNCTION IActiveScript_Clone (lpIUnknown, ppscript)

	FUNCADDR Clone (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	Clone	= XLONGAT (vtblAddr + 0x3C)
	IFZ Clone THEN RETURN ($$TRUE)

	RETURN @Clone (lpIUnknown, ppscript)

END FUNCTION

FUNCTION IActiveScriptParse_Release (lpIUnknown)

	FUNCADDR Release (XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	Release	= XLONGAT (vtblAddr + 0x08)
	IFZ Release THEN RETURN ($$TRUE)

	RETURN @Release (lpIUnknown)

END FUNCTION

FUNCTION IActiveScript_Release (lpIUnknown)

	FUNCADDR Release (XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	Release	= XLONGAT (vtblAddr + 0x08)
	IFZ Release THEN RETURN ($$TRUE)

	RETURN @Release (lpIUnknown)

END FUNCTION

FUNCTION WSTRING$ (addrWString)

	size = WideCharToMultiByte ($$CP_ACP, 0, addrWString, -1, 0, 0, NULL, NULL)

	IFZ size THEN RETURN ("")
	buffer$ = NULL$(size)
	WideCharToMultiByte ($$CP_ACP, 0, addrWString, -1, &buffer$, size, NULL, NULL)

	RETURN (CSIZE$(buffer$))

END FUNCTION

END PROGRAM